#include <avr/io.h>
#include <scmRTOS.h>

// Определение типов процессов приложения.
typedef OS::process<OS::pr0, 120> TProc1;
typedef OS::process<OS::pr1, 160> TProc2;

// Определение экземпляров классов процессов приложения.
TProc1 Proc1;
TProc2 Proc2;


int main(void)
{
// Настройка и запуск системного таймера.
    TCCR0B = (1 << CS01) | (1 << CS00);	// clk/64
    TIMSK0 |=  (1 << TOIE0);

    DDRC |= _BV(PC1);
    DDRC |= _BV(PC2);

    PORTC &= ~_BV(PC1);
    PORTC &= ~_BV(PC2);

    OS::Run(); // Запуск ОС.
};

namespace OS
{
    template<> OS_PROCESS void TProc1::Exec()
    {
        for(;;)
        {
            if (bit_is_set(PORTC, PC1)) {PORTC &= ~_BV(PC1);}
            else {PORTC |= _BV(PC1);};
            Sleep(10);
        };
    };

};

namespace OS
{
    template<> OS_PROCESS void TProc2::Exec()
    {
        for(;;)
        {
            if (bit_is_set(PORTC, PC2)) {PORTC &= ~_BV(PC2);}
            else {PORTC |= _BV(PC2);};
            Sleep(30);
        };
    };

};
